// Code generated by MockGen. DO NOT EDIT.
// Source: example.com/deepmocking/internal (interfaces: InterfaceType,InterfaceSubtype)

// Package mock_internal is a generated GoMock package.
package mock_internal

import (
	what "example.com/deepmocking/internal"
	gomock "github.com/golang/mock/gomock"
	reflect "reflect"
)

// MockInterfaceType is a mock of InterfaceType interface
type MockInterfaceType struct {
	ctrl     *gomock.Controller
	recorder *MockInterfaceTypeMockRecorder
}

// MockInterfaceTypeMockRecorder is the mock recorder for MockInterfaceType
type MockInterfaceTypeMockRecorder struct {
	mock *MockInterfaceType
}

// NewMockInterfaceType creates a new mock instance
func NewMockInterfaceType(ctrl *gomock.Controller) *MockInterfaceType {
	mock := &MockInterfaceType{ctrl: ctrl}
	mock.recorder = &MockInterfaceTypeMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use
func (m *MockInterfaceType) EXPECT() *MockInterfaceTypeMockRecorder {
	return m.recorder
}

// GetSub mocks base method
func (m *MockInterfaceType) GetSub() what.InterfaceSubtype {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetSub")
	ret0, _ := ret[0].(what.InterfaceSubtype)
	return ret0
}

// GetSub indicates an expected call of GetSub
func (mr *MockInterfaceTypeMockRecorder) GetSub() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetSub", reflect.TypeOf((*MockInterfaceType)(nil).GetSub))
}

// MockInterfaceSubtype is a mock of InterfaceSubtype interface
type MockInterfaceSubtype struct {
	ctrl     *gomock.Controller
	recorder *MockInterfaceSubtypeMockRecorder
}

// MockInterfaceSubtypeMockRecorder is the mock recorder for MockInterfaceSubtype
type MockInterfaceSubtypeMockRecorder struct {
	mock *MockInterfaceSubtype
}

// NewMockInterfaceSubtype creates a new mock instance
func NewMockInterfaceSubtype(ctrl *gomock.Controller) *MockInterfaceSubtype {
	mock := &MockInterfaceSubtype{ctrl: ctrl}
	mock.recorder = &MockInterfaceSubtypeMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use
func (m *MockInterfaceSubtype) EXPECT() *MockInterfaceSubtypeMockRecorder {
	return m.recorder
}

// GetA mocks base method
func (m *MockInterfaceSubtype) GetA() int {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetA")
	ret0, _ := ret[0].(int)
	return ret0
}

// GetA indicates an expected call of GetA
func (mr *MockInterfaceSubtypeMockRecorder) GetA() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetA", reflect.TypeOf((*MockInterfaceSubtype)(nil).GetA))
}
